{*************************************************}
{	CDAUDIO.PAS                               }
{	Copyright (C) 1994, 1995 Magnus Bck      }
{*************************************************}
{	Interface class for CDAUDIO-commands      }
{*************************************************}

Unit CDAudio;

Interface

Uses MMSystem, WinProcs, WinTypes, SysUtils, MMedia;

Type
	TCDAudio = CLASS(TMCI)
		Function Open : BOOLEAN; Virtual;
		Function PlayTMSF(FromPos, ToPos : PCHAR) : BOOLEAN; Virtual;
		Function SeekTMSF(ToPos : PCHAR) : BOOLEAN; Virtual;
		Function IsMediaPresent : BOOLEAN; Virtual;
		Function GetTrackCount : INTEGER; Virtual;
	End;

Implementation

Function TCDAudio.Open : BOOLEAN;

Const
	Command		: PCHAR = 'open %s shareable notify'#0;
	CommandAlias	: PCHAR = 'open %s alias %s shareable notify'#0;
	DefDevice		: PCHAR = 'cdaudio'#0;

Var
	Args : Array [0..1] Of POINTER;
	ReturnStr : Array [0..127] Of CHAR;
	Cmd : PCHAR;
	Return : LONGINT;

Begin
	Cmd := 'sdfsh98h23kdfnvlm,nvxc';
	If StrLen(DeviceID) = 0 Then
	Begin
		StrCopy(DeviceID,DefDevice);
		WvsPrintF(Cmd,Command,DefDevice);
	End
	Else
	Begin
		Args[0] := DefDevice;
		Args[1] := @DeviceID;
		WvsPrintF(Cmd,CommandAlias,Args);
	End;
	FillChar(ReturnStr,SizeOf(ReturnStr),#0);
	Return := mciSendString(Cmd,ReturnStr,SizeOf(ReturnStr),0);
	If Return = 0 Then
	Begin
		Open := True;
		Exit;
	End;
	Open := False;
	Error(Return);
End;

Function TCDAudio.PlayTMSF(FromPos, ToPos : PCHAR) : BOOLEAN;

Const
	Command		: PCHAR = 'play %s notify'#0;
	CommandFrom	: PCHAR = 'play %s from %s notify'#0;
	CommandTo		: PCHAR = 'play %s to %s notify'#0;
	CommandFromTo	: PCHAR = 'play %s from %s to %s notify'#0;
	SetTMSF		: PCHAR = 'set time format TMSF'#0;

Var
	Args2 : Array [0..1] Of POINTER;
	Args3 : Array [0..2] Of POINTER;
	ReturnStr : Array [0..127] Of CHAR;
	Return : LONGINT;
	Cmd : PCHAR;

Begin
	If not SetTimeFormatTMSF Then
	Begin
		PlayTMSF := False;
		Exit;
	End;
	If (StrComp(FromPos,'') = 0) and (StrComp(ToPos,'') = 0) Then
	Begin
		Cmd := 'sdfhsdfh098h4kjfhslk';
		WvsPrintF(Cmd,Command,DeviceID);
	End;
	If (StrComp(FromPos,'') = 0) and (StrComp(ToPos,'') <> 0) Then
	Begin
		Args2[0] := @DeviceID;
		Args2[1] := ToPos;
		Cmd := 'sdfhsdfh098h4kjfhslk';
		WvsPrintF(Cmd,CommandTo,Args2);
	End;
	If (StrComp(FromPos,'') <> 0) and (StrComp(ToPos,'') = 0) Then
	Begin
		Args2[0] := @DeviceID;
		Args2[1] := FromPos;
		Cmd := 'sdfhsdfh098h4kjfhslk';
		WvsPrintF(Cmd,CommandFrom,Args2);
	End;
	If (StrComp(FromPos,'') <> 0) and (StrComp(ToPos,'') <> 0) Then
	Begin
		Args3[0] := @DeviceID;
		Args3[1] := FromPos;
		Args3[2] := ToPos;
		Cmd := 'sdfhsdfh098h4kjfhslk';
		WvsPrintF(Cmd,CommandFromTo,Args3);
	End;
	FillChar(ReturnStr,SizeOf(ReturnStr),#0);
	Return := mciSendString(Cmd,ReturnStr,SizeOf(ReturnStr),0);
	If Return = 0 Then
	Begin
		PlayTMSF := True;
		Exit;
	End;
	PlayTMSF := False;
	Error(Return);
End;

Function TCDAudio.SeekTMSF(ToPos : PCHAR) : BOOLEAN;

Const
	Command		: PCHAR = 'seek %s to %s notify'#0;
	SetTMSF		: PCHAR = 'set time format TMSF'#0;

Var
	Args : Array [0..1] Of POINTER;
	ReturnStr : Array [0..127] Of CHAR;
	Return : LONGINT;
	Cmd : PCHAR;

Begin
	If not SetTimeFormatTMSF Then
	Begin
		SeekTMSF := False;
		Exit;
	End;
	Args[0] := @DeviceID;
	Args[1] := ToPos;
	Cmd := 'sdfhsdfh098h4kjfhslk';
	WvsPrintF(Cmd,Command,Args);
	FillChar(ReturnStr,SizeOf(ReturnStr),#0);
	Return := mciSendString(Cmd,ReturnStr,SizeOf(ReturnStr),0);
	If Return = 0 Then
	Begin
		SeekTMSF := True;
		Exit;
	End;
	SeekTMSF := False;
	Error(Return);
End;

Function TCDAudio.IsMediaPresent : BOOLEAN;

Const
	Command 	: PCHAR = 'status %s media present'#0;

Var
	ReturnStr : Array [0..127] Of CHAR;
	Return : LONGINT;
	Cmd : PCHAR;
	P : POINTER;

Begin
	Cmd := 'sdfhsdfh098h4kjfhslk';
	P := @DeviceID;
	WvsPrintF(Cmd,Command,P);
	FillChar(ReturnStr,SizeOf(ReturnStr),#0);
	Return := mciSendString(Cmd,ReturnStr,SizeOf(ReturnStr),0);
	If Return = 0 Then
	Begin
		IsMediaPresent := StrIComp(TrueStr,ReturnStr) = 0;
		Exit;
	End;
	IsMediaPresent := False;
	Error(Return);
End;

Function TCDAudio.GetTrackCount : INTEGER;

Const
	Command : PCHAR = 'status %s number of tracks'#0;

Var
	ReturnStr : Array [0..127] Of CHAR;
	Return : LONGINT;
	Temp, Err : INTEGER;
	Cmd : PCHAR;
	P : PCHAR;

Begin
	Cmd := 'sdfhsdfh098h4kjfhslk';
	P := 'sdfjsdhfksdjfh';
	P := StrPCopy(P,StrPas(DeviceID));
	WvsPrintF(Cmd,'status %s number of tracks',P);
	FillChar(ReturnStr,SizeOf(ReturnStr),#0);
	Return := mciSendString(Cmd,ReturnStr,SizeOf(ReturnStr),0);
	If Return = 0 Then
	Begin
		Val(StrPas(ReturnStr),Temp,Err);
		If Err = 0 Then
		Begin
			GetTrackCount := Temp;
			Exit;
		End;
	End;
	GetTrackCount := -1;
	Error(Return);
End;

END.