{*************************************************}
{ MMEDIA.PAS                                      }
{ Copyright (C) 1994, 1995 Magnus Bck            }
{*************************************************}
{ Interface class fr for MCI-commands            }
{*************************************************}

Unit MMedia;

Interface

Uses MMSystem, WinProcs, WinTypes, SysUtils, Forms, MessageB;

Const
	TrueStr		: PCHAR = 'true'#0;
	FalseStr		: PCHAR = 'false'#0;
	Mode_NotReady	: PCHAR = 'not ready'#0;
	Mode_Open		: PCHAR = 'open'#0;
	Mode_Paused	: PCHAR = 'paused'#0;
	Mode_Playing	: PCHAR = 'playing'#0;
	Mode_Seeking	: PCHAR = 'seeking'#0;
	Mode_Stopped	: PCHAR = 'stopped'#0;
	Mode_Playing_S	: PCHAR = 'spelar'#0;
	Mode_Stopped_S	: PCHAR = 'avstannad'#0;

{	TWaveAudio = OBJECT(TMCI)
	End;
	TSequencer = OBJECT(TMCI)
	End;
	TVideoOverlay = OBJECT(TMCI)
	End;
	TVideoDisc = OBJECT(TMCI)
	End;
	TAnimation = OBJECT(TMCI)
	End;}

Type
	TMCI = CLASS(TOBJECT)
		DisplayError	: BOOLEAN;
		DeviceID	 	: Array [0..50] Of CHAR;
		Parent		: TFORM;
		Function GetInstallName : PCHAR;
		Function GetQuantity : LONGINT;
		Function GetQuantityOpen : LONGINT;
		Function GetName(Index : INTEGER) : PCHAR;
		Function GetNameOpen(Index : INTEGER) : PCHAR;
		Function SetBreak(IsOn : BOOLEAN;VirtualKey : WORD) : LONGINT;
		Function CanEject : BOOLEAN; Virtual;
		Function CanPlay : BOOLEAN; Virtual;
		Function CanRecord : BOOLEAN; Virtual;
		Function CanSave : BOOLEAN; Virtual;
		Function IsCompound : BOOLEAN; Virtual;
		Function GetDeviceType : PCHAR; Virtual;
		Function HasAudio : BOOLEAN; Virtual;
		Function HasVideo : BOOLEAN; Virtual;
		Function UserFiles : BOOLEAN; Virtual;
		Function GetProductInfo : PCHAR;
		Function GetMode : PCHAR;
		Function SetDisplayError(NewValue : BOOLEAN) : BOOLEAN;
		Function Open : BOOLEAN; Virtual;
		Function Close : BOOLEAN; Virtual;
		Function Load(AFilename : PCHAR) : BOOLEAN; Virtual;
		Function Save(AFilename : PCHAR) : BOOLEAN; Virtual;
		Function Pause : BOOLEAN; Virtual;
		Function Resume : BOOLEAN; Virtual;
		Function Stop : BOOLEAN; Virtual;
		Function PlayMilli(FromPos, ToPos : LONGINT) : BOOLEAN; Virtual;
		Function RecordMilli(Overwrite : BOOLEAN;FromPos,
			ToPos : LONGINT) : BOOLEAN; Virtual;
		Function SeekMilli(ToPos : LONGINT) : BOOLEAN; Virtual;
		Function SeekToStart : BOOLEAN; Virtual;
		Function SeekToEnd : BOOLEAN; Virtual;
		Function SetAudio(Left, Right : BOOLEAN) : BOOLEAN; Virtual;
		Function SetDoor(IsOpen : BOOLEAN) : BOOLEAN; Virtual;
		Function SetVideo(IsVideo : BOOLEAN) : BOOLEAN; Virtual;
		Function GetCurrentTrack : INTEGER; Virtual;
		Function GetLengthMilli : LONGINT; Virtual;
		Function GetLengthTMSF : STRING; Virtual;
		Function GetTrackLengthMilli(TrackIndex : INTEGER) : LONGINT; Virtual;
		Function GetTrackLengthTMSF(TrackIndex : INTEGER) : STRING; Virtual;
		Function GetPosMilli : LONGINT; Virtual;
		Function GetPosTMSF : STRING; Virtual;
		Function GetTrackPosMilli(TrackIndex : INTEGER) : LONGINT; Virtual;
		Function IsReady : BOOLEAN; Virtual;
		Function GetStartPosMilli : LONGINT; Virtual;
		Function GetStartPosTMSF : STRING; Virtual;
		Function SetTimeFormatMilli : BOOLEAN; Virtual;
		Function SetTimeFormatTMSF : BOOLEAN; Virtual;
		Function ToPChar(Int : LONGINT) : PCHAR; Virtual;
		Procedure Error(TheError : LONGINT);
		Constructor Create(AParent : TFORM;ShouldDisplayError : BOOLEAN;
			AnAlias : PCHAR);
	End;

Implementation

Function TMCI.GetInstallName : PCHAR;

Const
	Command : PCHAR = 'sysinfo %s installname'#0;

Var
	ReturnStr : Array [0..127] Of CHAR;
	Return : LONGINT;
	Cmd : PCHAR;
	P : POINTER;

Begin
	Cmd := 'sdfhsdfh098h4kjfhslk';
	P := @DeviceID;
	WvsPrintF(Cmd,Command,P);
	FillChar(ReturnStr,SizeOf(ReturnStr),#0);
	Return := mciSendString(Cmd,ReturnStr,SizeOf(ReturnStr),0);
	If Return = 0 Then
	Begin
		GetInstallName := ReturnStr;
		Exit;
	End;
	GetInstallName := '';
	Error(Return);
End;

Function TMCI.GetQuantity : LONGINT;

Const
	Command : PCHAR = 'sysinfo %s quantity'#0;

Var
	ReturnStr : Array [0..127] Of CHAR;
	Return : LONGINT;
	Temp, Err : INTEGER;
	Cmd : PCHAR;
	P : POINTER;

Begin
	Cmd := 'sdfhsdfh098h4kjfhslk';
	P := @DeviceID;
	WvsPrintF(Cmd,Command,P);
	FillChar(ReturnStr,SizeOf(ReturnStr),#0);
	Return := mciSendString(Cmd,ReturnStr,SizeOf(ReturnStr),0);
	If Return = 0 Then
	Begin
		Val(StrPas(ReturnStr),Temp,Err);
		If Err = 0 Then
		Begin
			GetQuantity := Temp;
			Exit;
		End;
	End;
	GetQuantity := -1;
	Error(Return);
End;

Function TMCI.GetQuantityOpen : LONGINT;

Const
	Command : PCHAR = 'sysinfo %s quantity open'#0;

Var
	ReturnStr : Array [0..127] Of CHAR;
	Return : LONGINT;
	Temp, Err : INTEGER;
	Cmd : PCHAR;
	P : POINTER;

Begin
	Cmd := 'sdfhsdfh098h4kjfhslk';
	P := @DeviceID;
	WvsPrintF(Cmd,Command,P);
	FillChar(ReturnStr,SizeOf(ReturnStr),#0);
	Return := mciSendString(Cmd,ReturnStr,SizeOf(ReturnStr),0);
	If Return = 0 Then
	Begin
		Val(StrPas(ReturnStr),Temp,Err);
		If Err = 0 Then
		Begin
			GetQuantityOpen := Temp;
			Exit;
		End;
	End;
	GetQuantityOpen := -1;
	Error(Return);
End;

Function TMCI.GetName(Index : INTEGER) : PCHAR;

Const
	Command : PCHAR = 'sysinfo %s name %s'#0;

Var
	Args : Array [0..1] Of POINTER;
	ReturnStr : Array [0..127] Of CHAR;
	Return : LONGINT;
	Cmd : PCHAR;

Begin
	Args[0] := @DeviceID;
	Args[1] := ToPChar(Index);
	Cmd := 'sdfhsdfh098h4kjfhslk';
	WvsPrintF(Cmd,Command,Args);
	FillChar(ReturnStr,SizeOf(ReturnStr),#0);
	Return := mciSendString(Cmd,ReturnStr,SizeOf(ReturnStr),0);
	If Return = 0 Then
	Begin
		GetName := ReturnStr;
		Exit;
	End;
	GetName := '';
	Error(Return);
End;

Function TMCI.GetNameOpen(Index : INTEGER) : PCHAR;

Const
	Command : PCHAR = 'sysinfo %s name %s open'#0;

Var
	Args : Array [0..1] Of POINTER;
	ReturnStr : Array [0..127] Of CHAR;
	Return : LONGINT;
	Cmd : PCHAR;

Begin
	Args[0] := @DeviceID;
	Args[1] := ToPChar(Index);
	Cmd := 'sdfhsdfh098h4kjfhslk';
	WvsPrintF(Cmd,Command,Args);
	FillChar(ReturnStr,SizeOf(ReturnStr),#0);
	Return := mciSendString(Cmd,ReturnStr,SizeOf(ReturnStr),0);
	If Return = 0 Then
	Begin
		GetNameOpen := ReturnStr;
		Exit;
	End;
	GetNameOpen := '';
	Error(Return);
End;

Function TMCI.SetBreak(IsOn : BOOLEAN;VirtualKey : WORD) : LONGINT;

Const
	Command 	: PCHAR = 'break %s %s %s'#0;
	OnStr	: PCHAR = 'on'#0;
	OffStr	: PCHAR = 'off'#0;

Var
	Args : Array [0..2] Of POINTER;
	ReturnStr : Array [0..127] Of CHAR;
	Return : LONGINT;
	Cmd : PCHAR;

Begin
	Args[0] := @DeviceID;
	If IsOn Then
		Args[1] := OnStr
	Else
		Args[1] := OffStr;
	Args[2] := ToPChar(VirtualKey);
	Cmd := 'sdfhsdfh098h4kjfhslk';
	WvsPrintF(Cmd,Command,Args);
	FillChar(ReturnStr,SizeOf(ReturnStr),#0);
	Return := mciSendString(Cmd,ReturnStr,SizeOf(ReturnStr),0);
	If Return = 0 Then
	Begin
		SetBreak := Return;
		Exit;
	End;
	SetBreak := -1;
	Error(Return);
End;

Function TMCI.CanEject : BOOLEAN;

Const
	Command 	: PCHAR = 'capability %s can eject'#0;

Var
	ReturnStr : Array [0..127] Of CHAR;
	Return : LONGINT;
	Cmd : PCHAR;
	P : POINTER;

Begin
	Cmd := 'sdfhsdfh098h4kjfhslk';
	P := @DeviceID;
	WvsPrintF(Cmd,Command,P);
	FillChar(ReturnStr,SizeOf(ReturnStr),#0);
	Return := mciSendString(Cmd,ReturnStr,SizeOf(ReturnStr),0);
	If Return = 0 Then
	Begin
		CanEject := StrIComp(TrueStr,ReturnStr) = 0;
		Exit;
	End;
	CanEject := False;
	Error(Return);
End;

Function TMCI.CanPlay : BOOLEAN;

Const
	Command 	: PCHAR = 'capability %s can play'#0;

Var
	ReturnStr : Array [0..127] Of CHAR;
	Return : LONGINT;
	Cmd : PCHAR;
	P : POINTER;

Begin
	Cmd := 'sdfhsdfh098h4kjfhslk';
	P := @DeviceID;
	WvsPrintF(Cmd,Command,P);
	FillChar(ReturnStr,SizeOf(ReturnStr),#0);
	Return := mciSendString(Cmd,ReturnStr,SizeOf(ReturnStr),0);
	If Return = 0 Then
	Begin
		CanPlay := StrIComp(TrueStr,ReturnStr) = 0;
		Exit;
	End;
	CanPlay := False;
	Error(Return);
End;

Function TMCI.CanRecord : BOOLEAN;

Const
	Command 	: PCHAR = 'capability %s can record'#0;

Var
	ReturnStr : Array [0..127] Of CHAR;
	Return : LONGINT;
	Cmd : PCHAR;
	P : POINTER;

Begin
	Cmd := 'sdfhsdfh098h4kjfhslk';
	P := @DeviceID;
	WvsPrintF(Cmd,Command,P);
	FillChar(ReturnStr,SizeOf(ReturnStr),#0);
	Return := mciSendString(Cmd,ReturnStr,SizeOf(ReturnStr),0);
	If Return = 0 Then
	Begin
		CanRecord := StrIComp(TrueStr,ReturnStr) = 0;
		Exit;
	End;
	CanRecord := False;
	Error(Return);
End;

Function TMCI.CanSave : BOOLEAN;

Const
	Command 	: PCHAR = 'capability %s can save'#0;

Var
	ReturnStr : Array [0..127] Of CHAR;
	Return : LONGINT;
	Cmd : PCHAR;
	P : POINTER;

Begin
	Cmd := 'sdfhsdfh098h4kjfhslk';
	P := @DeviceID;
	WvsPrintF(Cmd,Command,P);
	FillChar(ReturnStr,SizeOf(ReturnStr),#0);
	Return := mciSendString(Cmd,ReturnStr,SizeOf(ReturnStr),0);
	If Return = 0 Then
	Begin
		CanSave := StrIComp(TrueStr,ReturnStr) = 0;
		Exit;
	End;
	CanSave := False;
	Error(Return);
End;

Function TMCI.IsCompound : BOOLEAN;

Const
	Command 	: PCHAR = 'capability %s compound device'#0;

Var
	ReturnStr : Array [0..127] Of CHAR;
	Return : LONGINT;
	Cmd : PCHAR;
	P : POINTER;

Begin
	Cmd := 'sdfhsdfh098h4kjfhslk';
	P := @DeviceID;
	WvsPrintF(Cmd,Command,P);
	FillChar(ReturnStr,SizeOf(ReturnStr),#0);
	Return := mciSendString(Cmd,ReturnStr,SizeOf(ReturnStr),0);
	If Return = 0 Then
	Begin
		IsCompound := StrIComp(TrueStr,ReturnStr) = 0;
		Exit;
	End;
	IsCompound := False;
	Error(Return);
End;

Function TMCI.GetDeviceType : PCHAR;

Const
	Command 	: PCHAR = 'capability %s device type'#0;

Var
	ReturnStr : Array [0..127] Of CHAR;
	Return : LONGINT;
	Cmd : PCHAR;
	P : POINTER;

Begin
	Cmd := 'sdfhsdfh098h4kjfhslk';
	P := @DeviceID;
	WvsPrintF(Cmd,Command,P);
	FillChar(ReturnStr,SizeOf(ReturnStr),#0);
	Return := mciSendString(Cmd,ReturnStr,SizeOf(ReturnStr),0);
	If Return = 0 Then
	Begin
		GetDeviceType := ReturnStr;
		Exit;
	End;
	GetDeviceType := '';
	Error(Return);
End;

Function TMCI.HasAudio : BOOLEAN;

Const
	Command 	: PCHAR = 'capability %s has audio'#0;

Var
	ReturnStr : Array [0..127] Of CHAR;
	Return : LONGINT;
	Cmd : PCHAR;
	P : POINTER;

Begin
	Cmd := 'sdfhsdfh098h4kjfhslk';
	P := @DeviceID;
	WvsPrintF(Cmd,Command,P);
	FillChar(ReturnStr,SizeOf(ReturnStr),#0);
	Return := mciSendString(Cmd,ReturnStr,SizeOf(ReturnStr),0);
	If Return = 0 Then
	Begin
		HasAudio := StrIComp(TrueStr,ReturnStr) = 0;
		Exit;
	End;
	HasAudio := False;
	Error(Return);
End;

Function TMCI.HasVideo : BOOLEAN;

Const
	Command 	: PCHAR = 'capability %s has video'#0;

Var
	ReturnStr : Array [0..127] Of CHAR;
	Return : LONGINT;
	Cmd : PCHAR;
	P : POINTER;

Begin
	Cmd := 'sdfhsdfh098h4kjfhslk';
	P := @DeviceID;
	WvsPrintF(Cmd,Command,P);
	FillChar(ReturnStr,SizeOf(ReturnStr),#0);
	Return := mciSendString(Cmd,ReturnStr,SizeOf(ReturnStr),0);
	If Return = 0 Then
	Begin
		HasVideo := StrIComp(TrueStr,ReturnStr) = 0;
		Exit;
	End;
	HasVideo := False;
	Error(Return);
End;

Function TMCI.UserFiles : BOOLEAN;

Const
	Command 	: PCHAR = 'capability %s user files'#0;

Var
	ReturnStr : Array [0..127] Of CHAR;
	Return : LONGINT;
	Cmd : PCHAR;
	P : POINTER;

Begin
	Cmd := 'sdfhsdfh098h4kjfhslk';
	P := @DeviceID;
	WvsPrintF(Cmd,Command,P);
	FillChar(ReturnStr,SizeOf(ReturnStr),#0);
	Return := mciSendString(Cmd,ReturnStr,SizeOf(ReturnStr),0);
	If Return = 0 Then
	Begin
		UserFiles := StrIComp(TrueStr,ReturnStr) = 0;
		Exit;
	End;
	UserFiles := False;
	Error(Return);
End;

Function TMCI.GetProductInfo : PCHAR;

Const
	Command 	: PCHAR = 'info %s product'#0;

Var
	ReturnStr : Array [0..127] Of CHAR;
	Return : LONGINT;
	Cmd : PCHAR;
	P : POINTER;

Begin
	Cmd := 'sdfhsdfh098h4kjfhslk';
	P := @DeviceID;
	WvsPrintF(Cmd,Command,P);
	FillChar(ReturnStr,SizeOf(ReturnStr),#0);
	Return := mciSendString(Cmd,ReturnStr,SizeOf(ReturnStr),0);
	If Return = 0 Then
	Begin
		GetProductInfo := ReturnStr;
		Exit;
	End;
	GetProductInfo := '';
	Error(Return);
End;

Function TMCI.GetMode : PCHAR;

Const
	Command 	: PCHAR = 'status %s mode'#0;

Var
	ReturnStr : Array [0..127] Of CHAR;
	Return : LONGINT;
	Cmd : PCHAR;
	P : POINTER;

Begin
	Cmd := 'sdfhsdfh098h4kjfhslk';
	P := @DeviceID;
	WvsPrintF(Cmd,Command,P);
	FillChar(ReturnStr,SizeOf(ReturnStr),#0);
	Return := mciSendString(Cmd,ReturnStr,SizeOf(ReturnStr),0);
	If Return = 0 Then
	Begin
		GetMode := ReturnStr;
		Exit;
	End;
	GetMode := '';
	Error(Return);
End;

Function TMCI.SetDisplayError(NewValue : BOOLEAN) : BOOLEAN;

Begin
	SetDisplayError := DisplayError;
	DisplayError := NewValue;
End;

Function TMCI.Open : BOOLEAN;

Begin

End;

Function TMCI.Close : BOOLEAN;

Const
	Command		: PCHAR = 'close %s'#0;

Var
	ReturnStr : Array [0..127] Of CHAR;
	Return : LONGINT;
	Cmd : PCHAR;
	P : POINTER;

Begin
	Cmd := 'sdfhsdfh098h4kjfhslk';
	P := @DeviceID;
	WvsPrintF(Cmd,Command,P);
	FillChar(ReturnStr,SizeOf(ReturnStr),#0);
	Return := mciSendString(Cmd,ReturnStr,SizeOf(ReturnStr),0);
	If Return = 0 Then
	Begin
		Close := True;
		Exit;
	End;
	Close := False;
	Error(Return);
End;

Function TMCI.Load(AFilename : PCHAR) : BOOLEAN;

Const
	Command		: PCHAR = 'load %s %s notify'#0;

Var
	Args : Array [0..1] Of POINTER;
	ReturnStr : Array [0..127] Of CHAR;
	Return : LONGINT;
	Cmd : PCHAR;

Begin
	Args[0] := @DeviceID;
	Args[1] := AFilename;
	Cmd := 'sdfhsdfh098h4kjfhslk';
	WvsPrintF(Cmd,Command,Args);
	FillChar(ReturnStr,SizeOf(ReturnStr),#0);
	Return := mciSendString(Cmd,ReturnStr,SizeOf(ReturnStr),0);
	If Return = 0 Then
	Begin
		Load := True;
		Exit;
	End;
	Load := False;
	Error(Return);
End;

Function TMCI.Save(AFilename : PCHAR) : BOOLEAN;

Const
	Command		: PCHAR = 'save %s %s notify'#0;

Var
	Args : Array [0..1] Of POINTER;
	ReturnStr : Array [0..127] Of CHAR;
	Return : LONGINT;
	Cmd : PCHAR;

Begin
	Args[0] := @DeviceID;
	Args[1] := AFilename;
	Cmd := 'sdfhsdfh098h4kjfhslk';
	WvsPrintF(Cmd,Command,Args);
	FillChar(ReturnStr,SizeOf(ReturnStr),#0);
	Return := mciSendString(Cmd,ReturnStr,SizeOf(ReturnStr),0);
	If Return = 0 Then
	Begin
		Save := True;
		Exit;
	End;
	Save := False;
	Error(Return);
End;

Function TMCI.Pause : BOOLEAN;

Const
	Command		: PCHAR = 'pause %s'#0;

Var
	ReturnStr : Array [0..127] Of CHAR;
	Return : LONGINT;
	Cmd : PCHAR;
	P : POINTER;

Begin
	Cmd := 'sdfhsdfh098h4kjfhslk';
	P := @DeviceID;
	WvsPrintF(Cmd,Command,P);
	FillChar(ReturnStr,SizeOf(ReturnStr),#0);
	Return := mciSendString(Cmd,ReturnStr,SizeOf(ReturnStr),0);
	If Return = 0 Then
	Begin
		Pause := True;
		Exit;
	End;
	Pause := False;
	Error(Return);
End;

Function TMCI.Resume : BOOLEAN;

Const
	Command		: PCHAR = 'resume %s'#0;

Var
	ReturnStr : Array [0..127] Of CHAR;
	Return : LONGINT;
	Cmd : PCHAR;
	P : POINTER;

Begin
	Cmd := 'sdfhsdfh098h4kjfhslk';
	P := @DeviceID;
	WvsPrintF(Cmd,Command,P);
	FillChar(ReturnStr,SizeOf(ReturnStr),#0);
	Return := mciSendString(Cmd,ReturnStr,SizeOf(ReturnStr),0);
	If Return = 0 Then
	Begin
		Resume := True;
		Exit;
	End;
	Resume := False;
	Error(Return);
End;

Function TMCI.Stop : BOOLEAN;

Const
	Command		: PCHAR = 'stop %s'#0;

Var
	ReturnStr : Array [0..127] Of CHAR;
	Return : LONGINT;
	Cmd : PCHAR;
	P : POINTER;

Begin
	Cmd := 'sdfhsdfh098h4kjfhslk';
	P := @DeviceID;
	WvsPrintF(Cmd,Command,P);
	FillChar(ReturnStr,SizeOf(ReturnStr),#0);
	Return := mciSendString(Cmd,ReturnStr,SizeOf(ReturnStr),0);
	If Return = 0 Then
	Begin
		Stop := True;
		Exit;
	End;
	Stop := False;
	Error(Return);
End;

Function TMCI.PlayMilli(FromPos, ToPos : LONGINT) : BOOLEAN;

Const
	Command		: PCHAR = 'play %s notify'#0;
	CommandFrom	: PCHAR = 'play %s from %s notify'#0;
	CommandTo		: PCHAR = 'play %s to %s notify'#0;
	CommandFromTo	: PCHAR = 'play %s from %s to %s notify'#0;
	SetMilli		: PCHAR = 'set time format milliseconds'#0;

Var
	Args2 : Array [0..1] Of POINTER;
	Args3 : Array [0..2] Of POINTER;
	ReturnStr : Array [0..127] Of CHAR;
	Return : LONGINT;
	Cmd : PCHAR;
	P : POINTER;

Begin
	If not SetTimeFormatMilli Then
	Begin
		PlayMilli := False;
		Exit;
	End;
	If (FromPos = -1) and (ToPos = -1) Then
	Begin
		Cmd := 'sdfhsdfh098h4kjfhslk';
		P := @DeviceID;
		WvsPrintF(Cmd,Command,P);
	End;
	If (FromPos = -1) and (ToPos <> -1) Then
	Begin
		Args2[0] := @DeviceID;
		Args2[1] := ToPChar(ToPos);
		Cmd := 'sdfhsdfh098h4kjfhslk';
		WvsPrintF(Cmd,CommandTo,Args2);
	End;
	If (FromPos <> -1) and (ToPos = -1) Then
	Begin
		Args2[0] := @DeviceID;
		Args2[1] := ToPChar(FromPos);
		Cmd := 'sdfhsdfh098h4kjfhslk';
		WvsPrintF(Cmd,CommandFrom,Args2);
	End;
	If (FromPos <> -1) and (ToPos <> -1) Then
	Begin
		Args3[0] := @DeviceID;
		Args3[1] := ToPChar(FromPos);
		Args3[2] := ToPChar(ToPos);
		Cmd := 'sdfhsdfh098h4kjfhslk';
		WvsPrintF(Cmd,CommandFromTo,Args3);
	End;
	FillChar(ReturnStr,SizeOf(ReturnStr),#0);
	Return := mciSendString(Cmd,ReturnStr,SizeOf(ReturnStr),0);
	If Return = 0 Then
	Begin
		PlayMilli := True;
		Exit;
	End;
	PlayMilli := False;
	Error(Return);
End;

Function TMCI.RecordMilli(Overwrite : BOOLEAN;FromPos,
	ToPos : LONGINT) : BOOLEAN;

Const
	Command			: PCHAR = 'record %s overwrite notify'#0;
	CommandFrom		: PCHAR = 'record %s from %s overwrite notify'#0;
	CommandTo			: PCHAR = 'record %s to %s overwrite notify'#0;
	CommandFromTo		: PCHAR = 'record %s from %s to %s overwrite notify'#0;
	CommandIns		: PCHAR = 'record %s insert notify'#0;
	CommandFromIns		: PCHAR = 'record %s from %s insert notify'#0;
	CommandToIns		: PCHAR = 'record %s to %s insert notify'#0;
	CommandFromToIns	: PCHAR = 'record %s from %s to %s insert notify'#0;
	SetMilli			: PCHAR = 'set time format milliseconds'#0;

Var
	Args2 : Array [0..1] Of POINTER;
	Args3 : Array [0..2] Of POINTER;
	ReturnStr : Array [0..127] Of CHAR;
	Return : LONGINT;
	Cmd : PCHAR;

Begin
	If not SetTimeFormatMilli Then
	Begin
		RecordMilli := False;
		Exit;
	End;
	If (FromPos = -1) and (ToPos = -1) Then
	Begin
		Cmd := 'sdfhsdfh098h4kjfhslk';
		If Overwrite Then
			WvsPrintF(Cmd,Command,DeviceID)
		Else
			WvsPrintF(Cmd,CommandIns,DeviceID);
	End;
	If (FromPos = -1) and (ToPos <> -1) Then
	Begin
		Args2[0] := @DeviceID;
		Args2[1] := ToPChar(ToPos);
		Cmd := 'sdfhsdfh098h4kjfhslk';
		If Overwrite Then
			WvsPrintF(Cmd,CommandTo,Args2)
		Else
			WvsPrintF(Cmd,CommandToIns,Args2);
	End;
	If (FromPos <> -1) and (ToPos = -1) Then
	Begin
		Args2[0] := @DeviceID;
		Args2[1] := ToPChar(FromPos);
		Cmd := 'sdfhsdfh098h4kjfhslk';
		If Overwrite Then
			WvsPrintF(Cmd,CommandFrom,Args2)
		Else
			WvsPrintF(Cmd,CommandFromIns,Args2);
	End;
	If (FromPos <> -1) and (ToPos <> -1) Then
	Begin
		Args3[0] := @DeviceID;
		Args3[1] := ToPChar(FromPos);
		Args3[2] := ToPChar(ToPos);
		Cmd := 'sdfhsdfh098h4kjfhslk';
		If Overwrite Then
			WvsPrintF(Cmd,CommandFromTo,Args3)
		Else
			WvsPrintF(Cmd,CommandFromToIns,Args3);
	End;
	FillChar(ReturnStr,SizeOf(ReturnStr),#0);
	Return := mciSendString(Cmd,ReturnStr,SizeOf(ReturnStr),0);
	If Return = 0 Then
	Begin
		RecordMilli := True;
		Exit;
	End;
	RecordMilli := False;
	Error(Return);
End;

Function TMCI.SeekMilli(ToPos : LONGINT) : BOOLEAN;

Const
	Command		: PCHAR = 'seek %s to %s notify'#0;
	SetMilli		: PCHAR = 'set time format milliseconds'#0;

Var
	Args : Array [0..1] Of POINTER;
	ReturnStr : Array [0..127] Of CHAR;
	Return : LONGINT;
	Cmd : PCHAR;

Begin
	If not SetTimeFormatMilli Then
	Begin
		SeekMilli := False;
		Exit;
	End;
	Args[0] := @DeviceID;
	Args[1] := ToPChar(ToPos);
	Cmd := 'sdfhsdfh098h4kjfhslk';
	WvsPrintF(Cmd,Command,Args);
	FillChar(ReturnStr,SizeOf(ReturnStr),#0);
	Return := mciSendString(Cmd,ReturnStr,SizeOf(ReturnStr),0);
	If Return = 0 Then
	Begin
		SeekMilli := True;
		Exit;
	End;
	SeekMilli := False;
	Error(Return);
End;

Function TMCI.SeekToStart : BOOLEAN;

Const
	Command		: PCHAR = 'seek %s to start'#0;

Var
	ReturnStr : Array [0..127] Of CHAR;
	Return : LONGINT;
	Cmd : PCHAR;
	P : POINTER;

Begin
	Cmd := 'sdfhsdfh098h4kjfhslk';
	P := @DeviceID;
	WvsPrintF(Cmd,Command,P);
	FillChar(ReturnStr,SizeOf(ReturnStr),#0);
	Return := mciSendString(Cmd,ReturnStr,SizeOf(ReturnStr),0);
	If Return = 0 Then
	Begin
		SeekToStart := True;
		Exit;
	End;
	SeekToStart := False;
	Error(Return);
End;

Function TMCI.SeekToEnd : BOOLEAN;

Const
	Command		: PCHAR = 'seek %s to end'#0;

Var
	ReturnStr : Array [0..127] Of CHAR;
	Return : LONGINT;
	Cmd : PCHAR;
	P : POINTER;

Begin
	Cmd := 'sdfhsdfh098h4kjfhslk';
	P := @DeviceID;
	WvsPrintF(Cmd,Command,P);
	FillChar(ReturnStr,SizeOf(ReturnStr),#0);
	Return := mciSendString(Cmd,ReturnStr,SizeOf(ReturnStr),0);
	If Return = 0 Then
	Begin
		SeekToEnd := True;
		Exit;
	End;
	SeekToEnd := False;
	Error(Return);
End;

Function TMCI.SetAudio(Left, Right : BOOLEAN) : BOOLEAN;

Const
	CommandAllOff		: PCHAR = 'set %s audio all off'#0;
	CommandAllOn		: PCHAR = 'set %s audio all on'#0;
	CommandLeftOff		: PCHAR = 'set %s audio left off'#0;
	CommandLeftOn		: PCHAR = 'set %s audio left on'#0;
	CommandRightOff	: PCHAR = 'set %s audio right off'#0;
	CommandRightOn		: PCHAR = 'set %s audio right on'#0;

Var
	ReturnStr : Array [0..127] Of CHAR;
	Return : LONGINT;
	Cmd : PCHAR;

Begin
	Cmd := 'sdfhsdfh098h4kjfhslk';
	If Left and Right Then
		WvsPrintF(Cmd,CommandAllOn,DeviceID);
	If (not Left) and (not Right) Then
		WvsPrintF(Cmd,CommandAllOff,DeviceID);
	If Left and (not Right) Then
	Begin
		WvsPrintF(Cmd,CommandLeftOn,DeviceID);
		FillChar(ReturnStr,SizeOf(ReturnStr),#0);
		Return := mciSendString(Cmd,ReturnStr,SizeOf(ReturnStr),0);
		Cmd := 'sdfhsdfh098h4kjfhslk';
		WvsPrintF(Cmd,CommandRightOff,DeviceID);
		FillChar(ReturnStr,SizeOf(ReturnStr),#0);
		Return := mciSendString(Cmd,ReturnStr,SizeOf(ReturnStr),0);
	End;
	If (not Left) and Right Then
	Begin
		WvsPrintF(Cmd,CommandLeftOff,DeviceID);
		FillChar(ReturnStr,SizeOf(ReturnStr),#0);
		Return := mciSendString(Cmd,ReturnStr,SizeOf(ReturnStr),0);
		Cmd := 'sdfhsdfh098h4kjfhslk';
		WvsPrintF(Cmd,CommandRightOn,DeviceID);
		FillChar(ReturnStr,SizeOf(ReturnStr),#0);
		Return := mciSendString(Cmd,ReturnStr,SizeOf(ReturnStr),0);
	End;
	If Left = Right Then
	Begin
		FillChar(ReturnStr,SizeOf(ReturnStr),#0);
		Return := mciSendString(Cmd,ReturnStr,SizeOf(ReturnStr),0);
	End;
	If Return = 0 Then
	Begin
		SetAudio := True;
		Exit;
	End;
	SetAudio := False;
	Error(Return);
End;

Function TMCI.SetDoor(IsOpen : BOOLEAN) : BOOLEAN;

Const
	CommandOpen	: PCHAR = 'set %s door open'#0;
	CommandClosed	: PCHAR = 'set %s door closed'#0;

Var
	ReturnStr : Array [0..127] Of CHAR;
	Return : LONGINT;
	Cmd : PCHAR;
	P : POINTER;

Begin
	Cmd := 'sdfhsdfh098h4kjfhslk';
	P := @DeviceID;
	If IsOpen Then
		WvsPrintF(Cmd,CommandOpen,P)
	Else
		WvsPrintF(Cmd,CommandClosed,P);
	FillChar(ReturnStr,SizeOf(ReturnStr),#0);
	Return := mciSendString(Cmd,ReturnStr,SizeOf(ReturnStr),0);
	If Return = 0 Then
	Begin
		SetDoor := True;
		Exit;
	End;
	SetDoor := False;
	Error(Return);
End;

Function TMCI.SetVideo(IsVideo : BOOLEAN) : BOOLEAN;

Const
	CommandOn		: PCHAR = 'set %s video on'#0;
	CommandOff	: PCHAR = 'set %s video off'#0;

Var
	ReturnStr : Array [0..127] Of CHAR;
	Return : LONGINT;
	Cmd : PCHAR;

Begin
	Cmd := 'sdfhsdfh098h4kjfhslk';
	If IsVideo Then
		WvsPrintF(Cmd,CommandOn,DeviceID)
	Else
		WvsPrintF(Cmd,CommandOff,DeviceID);
	FillChar(ReturnStr,SizeOf(ReturnStr),#0);
	Return := mciSendString(Cmd,ReturnStr,SizeOf(ReturnStr),0);
	If Return = 0 Then
	Begin
		SetVideo := True;
		Exit;
	End;
	SetVideo := False;
	Error(Return);
End;

Function TMCI.GetCurrentTrack : INTEGER;

Const
	Command : PCHAR = 'status %s current track'#0;

Var
	ReturnStr : Array [0..127] Of CHAR;
	Return : LONGINT;
	Temp, Err : INTEGER;
	Cmd : PCHAR;
	P : POINTER;

Begin
	Cmd := 'sdfhsdfh098h4kjfhslk';
	P := @DeviceID;
	WvsPrintF(Cmd,Command,P);
	FillChar(ReturnStr,SizeOf(ReturnStr),#0);
	Return := mciSendString(Cmd,ReturnStr,SizeOf(ReturnStr),0);
	If Return = 0 Then
	Begin
		Val(StrPas(ReturnStr),Temp,Err);
		If Err = 0 Then
		Begin
			GetCurrentTrack := Temp;
			Exit;
		End;
	End;
	GetCurrentTrack := -1;
	Error(Return);
End;

Function TMCI.GetLengthMilli : LONGINT;

Const
	Command	: PCHAR = 'status %s length'#0;
	SetMilli	: PCHAR = 'set time format milliseconds'#0;

Var
	ReturnStr : Array [0..127] Of CHAR;
	Return : LONGINT;
	Temp : LONGINT;
	Err : INTEGER;
	Cmd : PCHAR;
{	P : POINTER;}
	P : PCHAR;

Begin
	If not SetTimeFormatMilli Then
	Begin
		GetLengthMilli := -1;
		Exit;
	End;
	Cmd := 'sdfhsdfh098h4kjfhslk';
	P := 'sdfjsdhfksdjfh';
	P := StrPCopy(P,StrPas(DeviceID));
	WvsPrintF(Cmd,'status %s length',P);
	FillChar(ReturnStr,SizeOf(ReturnStr),#0);
	Return := mciSendString(Cmd,ReturnStr,SizeOf(ReturnStr),0);
	If Return = 0 Then
	Begin
		Val(StrPas(ReturnStr),Temp,Err);
		If Err = 0 Then
		Begin
			GetLengthMilli := Temp;
			Exit;
		End;
	End;
	GetLengthMilli := -1;
	Error(Return);
End;

Function TMCI.GetLengthTMSF : STRING;

Const
	Command	: PCHAR = 'status %s length'#0;
	SetTMSF	: PCHAR = 'set time format TMSF'#0;

Var
	ReturnStr : Array [0..127] Of CHAR;
	Return : LONGINT;
	Temp : LONGINT;
	Err : INTEGER;
	Cmd : PCHAR;
	P : POINTER;

Begin
	If not SetTimeFormatTMSF Then
	Begin
		GetLengthTMSF := '';
		Exit;
	End;
	Cmd := 'sdfhsdfh098h4kjfhslk';
	P := @DeviceID;
	WvsPrintF(Cmd,Command,P);
	FillChar(ReturnStr,SizeOf(ReturnStr),#0);
	Return := mciSendString(Cmd,ReturnStr,SizeOf(ReturnStr),0);
	If Return = 0 Then
	Begin
		GetLengthTMSF := StrPas(ReturnStr);
		Exit;
	End;
	GetLengthTMSF := '';
	Error(Return);
End;

Function TMCI.GetTrackLengthMilli(TrackIndex : INTEGER) : LONGINT;

Const
	Command	: PCHAR = 'status %s length track %s'#0;
	SetMilli	: PCHAR = 'set time format milliseconds'#0;

Var
	Args : Array [0..1] Of POINTER;
	ReturnStr : Array [0..127] Of CHAR;
	Return : LONGINT;
	Temp : LONGINT;
	Err : INTEGER;
	Cmd : PCHAR;

Begin
	If not SetTimeFormatMilli Then
	Begin
		GetTrackLengthMilli := -1;
		Exit;
	End;
	Args[0] := @DeviceID;
	Args[1] := ToPChar(TrackIndex);
	Cmd := 'sdfhsdfh098h4kjfhslk';
	WvsPrintF(Cmd,Command,Args);
	FillChar(ReturnStr,SizeOf(ReturnStr),#0);
	Return := mciSendString(Cmd,ReturnStr,SizeOf(ReturnStr),0);
	If Return = 0 Then
	Begin
		Val(StrPas(ReturnStr),Temp,Err);
		If Err = 0 Then
		Begin
			GetTrackLengthMilli := Temp;
			Exit;
		End;
	End;
	GetTrackLengthMilli := -1;
	Error(Return);
End;

Function TMCI.GetTrackLengthTMSF(TrackIndex : INTEGER) : STRING;

Const
	Command	: PCHAR = 'status %s length track %s'#0;
	SetTMSF	: PCHAR = 'set time format TMSF'#0;

Var
	Args : Array [0..1] Of POINTER;
	ReturnStr : Array [0..127] Of CHAR;
	Return : LONGINT;
	Temp : LONGINT;
	Err : INTEGER;
{	Cmd : PCHAR;}
	Cmd : Array [0..100] Of CHAR;
	S, S2 : STRING;

Begin
	If not SetTimeFormatTMSF Then
	Begin
		GetTrackLengthTMSF := '';
		Exit;
	End;
{	Args[0] := @DeviceID;
	Args[1] := ToPChar(TrackIndex);
	Cmd := 'sdfhsdfh098h4kjfhslk';
	WvsPrintF(Cmd,Command,Args);}
	S := 'status  length track  ';
	Str(TrackIndex,S2);
	Insert(StrPas(DeviceID),S,8);
	Insert(S2,S,Length(S));
	FillChar(Cmd,SizeOf(Cmd),#0);
	StrPCopy(Cmd,S);
	FillChar(ReturnStr,SizeOf(ReturnStr),#0);
	Return := mciSendString(Cmd,ReturnStr,SizeOf(ReturnStr),0);
	If Return = 0 Then
	Begin
		GetTrackLengthTMSF := StrPas(ReturnStr);
		Exit;
	End;
	GetTrackLengthTMSF := '';
	Error(Return);
End;

Function TMCI.GetPosMilli : LONGINT;

Const
	Command	: PCHAR = 'status %s position'#0;
	SetMilli	: PCHAR = 'set time format milliseconds'#0;

Var
	ReturnStr : Array [0..127] Of CHAR;
	Return : LONGINT;
	Temp : LONGINT;
	Err : INTEGER;
{	Cmd : PCHAR;}
	Cmd : Array [0..100] Of CHAR;
	P : POINTER;
	S : STRING;

Begin
	If not SetTimeFormatMilli Then
	Begin
		GetPosMilli := -1;
		Exit;
	End;
	S := 'status  position';
	Insert(StrPas(DeviceID),S,8);
{	Cmd := 'sdfhsdfh098h4kjfhslk';
	P := @DeviceID;
	WvsPrintF(Cmd,'set %s time format TMSF',P);}
	FillChar(Cmd,SizeOf(Cmd),#0);
	StrPCopy(Cmd,S);
{	Cmd := 'sdfhsdfh098h4kjfhslk';
	P := @DeviceID;
	WvsPrintF(Cmd,Command,P);}
	FillChar(ReturnStr,SizeOf(ReturnStr),#0);
	Return := mciSendString(Cmd,ReturnStr,SizeOf(ReturnStr),0);
	If Return = 0 Then
	Begin
		Val(StrPas(ReturnStr),Temp,Err);
		If Err = 0 Then
		Begin
			GetPosMilli := Temp;
			Exit;
		End;
	End;
	GetPosMilli := -1;
	Error(Return);
End;

Function TMCI.GetPosTMSF : STRING;

Const
	Command	: PCHAR = 'status %s position'#0;
	SetTMSF	: PCHAR = 'set time format TMSF'#0;

Var
	ReturnStr : Array [0..127] Of CHAR;
	Return : LONGINT;
	Temp : LONGINT;
	Err : INTEGER;
{	Cmd : PCHAR;}
	Cmd : Array [0..100] Of CHAR;
	P : POINTER;
	S : STRING;

Begin
	If not SetTimeFormatTMSF Then
	Begin
		GetPosTMSF := '';
		Exit;
	End;
	S := 'status  position';
	Insert(StrPas(DeviceID),S,8);
{	Cmd := 'sdfhsdfh098h4kjfhslk';
	P := @DeviceID;
	WvsPrintF(Cmd,'set %s time format TMSF',P);}
	FillChar(Cmd,SizeOf(Cmd),#0);
	StrPCopy(Cmd,S);
{	Cmd := 'sdfhsdfh098h4kjfhslk';
	P := @DeviceID;
	WvsPrintF(Cmd,Command,P);}
	FillChar(ReturnStr,SizeOf(ReturnStr),#0);
	Return := mciSendString(Cmd,ReturnStr,SizeOf(ReturnStr),0);
	If Return = 0 Then
	Begin
		GetPosTMSF := StrPas(ReturnStr);
		Exit;
	End;
	GetPosTMSF := '';
	Error(Return);
End;

Function TMCI.GetTrackPosMilli(TrackIndex : INTEGER) : LONGINT;

Const
	Command	: PCHAR = 'status %s position track %s'#0;
	SetMilli	: PCHAR = 'set time format milliseconds'#0;

Var
	Args : Array [0..1] Of POINTER;
	ReturnStr : Array [0..127] Of CHAR;
	Return : LONGINT;
	Temp : LONGINT;
	Err : INTEGER;
	Cmd : PCHAR;

Begin
	If not SetTimeFormatMilli Then
	Begin
		GetTrackPosMilli := -1;
		Exit;
	End;
	Args[0] := @DeviceID;
	Args[1] := ToPChar(TrackIndex);
	Cmd := 'sdfhsdfh098h4kjfhslk';
	WvsPrintF(Cmd,Command,Args);
	FillChar(ReturnStr,SizeOf(ReturnStr),#0);
	Return := mciSendString(Cmd,ReturnStr,SizeOf(ReturnStr),0);
	If Return = 0 Then
	Begin
		Val(StrPas(ReturnStr),Temp,Err);
		If Err = 0 Then
		Begin
			GetTrackPosMilli := Temp;
			Exit;
		End;
	End;
	GetTrackPosMilli := -1;
	Error(Return);
End;

Function TMCI.IsReady : BOOLEAN;

Const
	Command 	: PCHAR = 'status %s ready'#0;

Var
	ReturnStr : Array [0..127] Of CHAR;
	Return : LONGINT;
	Cmd : PCHAR;
	P : POINTER;

Begin
	Cmd := 'sdfhsdfh098h4kjfhslk';
	P := @DeviceID;
	WvsPrintF(Cmd,Command,P);
	FillChar(ReturnStr,SizeOf(ReturnStr),#0);
	Return := mciSendString(Cmd,ReturnStr,SizeOf(ReturnStr),0);
	If Return = 0 Then
	Begin
		IsReady := StrIComp(TrueStr,ReturnStr) = 0;
		Exit;
	End;
	IsReady := False;
	Error(Return);
End;

Function TMCI.GetStartPosMilli : LONGINT;

Const
	Command	: PCHAR = 'status %s start position'#0;
	SetMilli	: PCHAR = 'set time format milliseconds'#0;

Var
	ReturnStr : Array [0..127] Of CHAR;
	Return : LONGINT;
	Temp : LONGINT;
	Err : INTEGER;
	Cmd : PCHAR;
	P : POINTER;

Begin
	If not SetTimeFormatMilli Then
	Begin
		GetStartPosMilli := -1;
		Exit;
	End;
	Cmd := 'sdfhsdfh098h4kjfhslk';
	P := @DeviceID;
	WvsPrintF(Cmd,Command,P);
	FillChar(ReturnStr,SizeOf(ReturnStr),#0);
	Return := mciSendString(Cmd,ReturnStr,SizeOf(ReturnStr),0);
	If Return = 0 Then
	Begin
		Val(StrPas(ReturnStr),Temp,Err);
		If Err = 0 Then
		Begin
			GetStartPosMilli := Temp;
			Exit;
		End;
	End;
	GetStartPosMilli := -1;
	Error(Return);
End;

Function TMCI.GetStartPosTMSF : STRING;

Const
	Command	: PCHAR = 'status %s start position'#0;
	SetTMSF	: PCHAR = 'set time format TMSF'#0;

Var
	ReturnStr : Array [0..127] Of CHAR;
	Return : LONGINT;
	Temp : LONGINT;
	Err : INTEGER;
	Cmd : PCHAR;
	P : POINTER;

Begin
	If not SetTimeFormatTMSF Then
	Begin
		GetStartPosTMSF := '';
		Exit;
	End;
	Cmd := 'sdfhsdfh098h4kjfhslk';
	P := @DeviceID;
	WvsPrintF(Cmd,Command,P);
	FillChar(ReturnStr,SizeOf(ReturnStr),#0);
	Return := mciSendString(Cmd,ReturnStr,SizeOf(ReturnStr),0);
	If Return = 0 Then
	Begin
		GetStartPosTMSF := StrPas(ReturnStr);
		Exit;
	End;
	GetStartPosTMSF := '';
	Error(Return);
End;

Function TMCI.SetTimeFormatMilli : BOOLEAN;

Const
	Command 	: PCHAR = 'set %s time format milliseconds'#0;

Var
	ReturnStr : Array [0..127] Of CHAR;
	Return : LONGINT;
	Cmd : PCHAR;
	P : POINTER;

Begin
	Cmd := 'sdfhsdfh098h4kjfhslk';
	P := @DeviceID;
	WvsPrintF(Cmd,Command,P);
	FillChar(ReturnStr,SizeOf(ReturnStr),#0);
	Return := mciSendString(Cmd,ReturnStr,SizeOf(ReturnStr),0);
	If Return = 0 Then
	Begin
		SetTimeFormatMilli := True;
		Exit;
	End;
	SetTimeFormatMilli := False;
	Error(Return);
End;

Function TMCI.SetTimeFormatTMSF : BOOLEAN;

Const
	Command 	: PCHAR = 'set %s time format TMSF'#0;

Var
	ReturnStr : Array [0..127] Of CHAR;
	Return : LONGINT;
{	Cmd : PCHAR;}
	Cmd : Array [0..100] Of CHAR;
	P : POINTER;
	S : STRING;

Begin
	S := 'set  time format TMSF';
	Insert(StrPas(DeviceID),S,5);
{	Cmd := 'sdfhsdfh098h4kjfhslk';
	P := @DeviceID;
	WvsPrintF(Cmd,'set %s time format TMSF',P);}
	FillChar(Cmd,SizeOf(Cmd),#0);
	StrPCopy(Cmd,S);
	FillChar(ReturnStr,SizeOf(ReturnStr),#0);
	Return := mciSendString(Cmd,ReturnStr,SizeOf(ReturnStr),0);
	If Return = 0 Then
	Begin
		SetTimeFormatTMSF := True;
		Exit;
	End;
	SetTimeFormatTMSF := False;
	Error(Return);
End;

Function TMCI.ToPChar(Int : LONGINT) : PCHAR;

Var
	Temp : Array [0..100] Of CHAR;
	S : STRING;

Begin
	Str(Int,S);
	FillChar(Temp,SizeOf(Temp),#0);
	StrPCopy(Temp,S);
	ToPChar := Temp;
End;

Procedure TMCI.Error(TheError : LONGINT);

Const
	Caption	: PCHAR = 'Fel MCI%ld'#0;

Var
	CaptionMsg : PCHAR;
	ErrorMsg : Array [0..200] Of CHAR;

Begin
	If (TheError <> 0) and DisplayError Then
	Begin
		FillChar(ErrorMsg,SizeOf(ErrorMsg),#0);
		CaptionMsg := 'sdfjshfkjhsdlfkjshlfkjh';
		WvsPrintF(CaptionMsg,Caption,TheError);
		mciGetErrorString(TheError,ErrorMsg,SizeOf(ErrorMsg));
		MsgBox(Parent,ErrorMsg,StrPas(CaptionMsg),mb_OK or mb_IconExclamation);
	End;
End;

Constructor TMCI.Create(AParent : TFORM;ShouldDisplayError : BOOLEAN;
	AnAlias : PCHAR);

Begin
	Inherited Create;
	Parent := AParent;
	DisplayError := ShouldDisplayError;
	FillChar(DeviceID,SizeOf(DeviceID),#0);
	If AnAlias <> nil Then
		StrCopy(DeviceID,AnAlias);
End;

END.
